/* EXPAND COMPRESSED FILE */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <sys/time.h>

/* DEFINE BY MACRO  "#define long int"
IF INT IS AT LEAST FOUR BYTES */

#define FL fflush(stdout) ;
#define TR(w,x,y,z) { static long\
 trct=500 ; if (trct-->0)\
 printf("\n x %w y %w z %w",x,y,z) ;\
 if (trct==0) printf("end trace x,y,z") ;\
 FL }

#define VS(v,op,n) {long nZ=0 ; while (nZ<n) \
(v)[nZ] op, nZ++ ; }

#define GPNO 8
#define GPSZ 25
#define FAST 6
#define FASTMASK 63
/*
#define CIPHER k4=key[z^k4] ;\
               k5=key[z^k5] ; k3+=k4^k5 ;
*/
#ifdef CIPHER
#define RD while (bfct<max8) { z=getc(fpr) ;\
if (z==EOF) { z=0 ; if (EOFct++>3) {\
error="end of file too early " ; goto err ;}}\
bff=(bff<<8)+z^k3 ; CIPHER bfct+=8 ; }

#else
#define RD while (bfct<max8) { z=getc(fpr) ;\
if (z==EOF) { z=0 ; if (EOFct++>3) {\
error="end of file too early " ; goto err ;}}\
bff=(bff<<8)+z ; bfct+=8 ;  }
#endif


    /* generates decode tables from the code
length table      */

long huffgendec( long *len, long n, long *start,
 long *offset, long *val,
 long fast, long *code, long *size)   {
long chain[1000], chainstart[25],
   m,p,q,z,y=1,x=0,s=0 ;

if (n>1000) { fprintf(stderr,"%s",
  "\n genhuffdec called with n>1000\n") ;
  return n ; }
VS(chainstart,= -1,25)
VS(size,=fast+1,1<<fast)

for (m=0 ; m<n ; m++)
   if (z=len[m])
      chain[m]=chainstart[z],
      chainstart[z]=m ;

/* assumes len[n-1] has maximumum used length*/
for ( m=len[n-1] ; m ; m--,y<<=1) {
   start[m]=x ;
   offset[m]=s ;
   if (chainstart[m]>=0) {
      p=chainstart[m] ;
      while (p>=0)  {
         val[s++]=p ;
         if (m<=fast)      {
            z=x>>len[n-1]-m ;
            z<<=fast-m ;
            for (q=z ; q<z+(1<<fast-m) ; q++ )
               code[q]=p,
               size[q]=m ; }
         x+=y ;
         p=chain[p] ;
                   }     }
                           }
if (x!=1<<len[n-1]) { fprintf(stderr,
   "\ngenhuffdec error in code sum %x\n",
      x-(1<<len[m-1])) ;
   return 2 ;  }

return 0 ; }

   /* MAIN PROGRAM */
int main (long argc, char *argv[]) {
char chl[500], *error ;
#ifdef CIPHER
static unsigned char key[256],
k1,k2,k3,k4,k5 ;
#endif
static long
  space[ (GPNO<<FAST+1)+GPNO*310 ],
  r[260],      /* move to front table */
  len[260],   /* code length table */
  tf[260],  /* frequency table to restore
               original order */
  msk[GPNO],
  mx[GPNO],
  tbdec[256],
  slist[GPNO],
  dspace = (2<<FAST)+310,
  zn, x=0, y, z, z1, m, n, p,
  argcc=0,  /* counts to argc */
  silent=1, /* selects amount of print */
  keep=0,   /*  source file removed if zero */
  errct=0,  /* error count */
  errlim=1, /* limit allowed for errors */
  chsz,    /* 2+ actual alphabet size */
  EOFct ;   /* EOF count allow for 4 */
static unsigned *v = 0;
static unsigned long bsize=200000 ;
FILE *fpr, *fpw, *fopen() ;

if ( argc < 2 ) {
  printf (
"Switches:"
"\nKn use a block size of 1000n"
"\n  space (1000 n + 65000) sizeof long + n bytes (default 200,000)"
"\nkn keep the original file if n=0 otherwise delete if no errors"
"\n  default n=1 i.e. delete"
"\nsn n=0 no printing"
"\n  if n an odd multiple of"
"\n  1 : print compression data and files, or files expanded"
"\n  2 : print extra information"
"\n    prints when block size has to be reduced due to slow sorting"
"\n    prints when block size reduced to allow a long prefix"
"\n    for zero strings in ecess of 1000."
"\n    prints millibits for,tables, selectors,number of iterations after"
"\n    first sweep, number of groups used, and size of groups."
"\n  4 : self followed by final selection frequencies, and GAIN followed"
"\n    by iteration gain in millibits, followed by the number of bits"
"\n    used for the character coding last time and this time."
"\n  8 : prints all the selections after the last iteration."
"\n    Advisable only for small files. default n=1"
"\nmn bred only"
"\n  n=d1 d2 d3, three decimals."
"\n  d1 0-7 gives extra tables used"
"\n  d2 0-3 gives size of groups, 25, 50, 100 or 200"
"\n  d3 limits the number of repeat scans 0-9 if no convergence"
"\n  default n=0, i.e. single table."
"\nwn bred only"
"\n  n is the work limit for the sorting routine. It measures"
"\n  the work done in in sort comparisons excess of DEPTH characters deep."
"\n  The DEPTH macro may be adjusted before compilation"
"\n  default 40,000,000"
"\nen n is the error limit. When errors are detected, the next"
"\n  file may be tried, until the limit is reached."
"\n  default n=1"
"\nThe file name is extended by . when compressed. The file to be expanded"
"\nmust end its name with a ."
"\n---"
"\nThe above was from bred3.ps."
"\nIn addition to miscellanous fixes I made the following changes: "
"\n * quick hack to allow >8MB blocks for bexp (now needs 5n for >16MB)"
"\n * 'bred foo' outputs 'foo.bred' instead of 'foo.'"
"\n * added -Mn which works like -Kn * 1000"
"\n * -k0 is default (keep files)"
"\n * -w0 is a special hack for disabling the work limit (for max comp.)"
"\nNote that bexp needs -Kn/-Mn switch like bred."
"\n                                               - Sami, 2009, March 27."
"\n"
  );
  return 0;
}

VS(space,=0,GPNO*dspace)

while (++argcc<argc && errct<errlim)
{long
 bff=0,
 bfct=0,
x=EOFct=0 ;

#ifdef CIPHER
k3=0 ;
k1=(k2) ? 32 : 0 ;
#endif

    /*  OPTION handling */
while ( chl[x]=argv[argcc][x] ) x++ ;
if (chl[0]=='-')     {
   zn=2 ; x=0 ;
   while (chl[zn]) x=10*x + chl[zn++]-'0' ;

   switch ( argv[argcc][1] )        {
case 's' : silent=x ; break ;
case 'k' : keep=x ; break ;
case 'M': x*=1000;
case 'K' : bsize=1000*x ; break ;
#ifdef CIPHER
case 'p' : if (* ( argv[argcc]+2) )
             k2=argcc ;
           else { k2=k3=k4=k5=0 ;
                for (x=0 ; x<256 ; x++ )
                  key[x]=0 ;  }
           break ;
#endif
case 'e' : errlim=x ; break ;
default  : { error=" option wrong " ;
             errct=errlim ; goto err ; }
                                            }
          continue ;  }

    /* FILE HANDLING */
if ((fpr=fopen(argv[argcc],"rb"))==NULL)
  { error="cannot open to read" ;
  goto err1 ; }

if ( x<6||chl[x-5]!='.'||chl[x-4]!='b'||chl[x-3]!='r'||chl[x-2]!='e'||chl[x-1]!='d' )
  { error=" no .bred terminator " ;
  goto err1 ; }

chl[x-5]=0 ;
if ((fpw=fopen(chl,"wb"))== NULL)
  { error="cannot open to write " ;
  goto err ;}
//if (bsize%1000==0)
//   bsize+=16,
if ( !v )
   v= (unsigned *) malloc(bsize*4+bsize*(bsize>(1U<<24))+16*5);

if (v==0) { error=
    "not enough space from malloc" ;
    errct=errlim ; goto err ; }

    /* MAIN ROUTINE */
while (1)
{{
long
 k, s,
 gpno,
 gpsz,
 gct,
 gpnoo,
 max,
 max8=8,
 mask,

* tab,  /* start codes for lengths,
             left aligned */
* tabch,    /* starts in output list
                 for length */
* tabval,  /* output list ordered by code */
* val8,    /* fast value table  */
* len8 ;  /* fast length table,
               indexed by nextcode */
VS(tf,=0,260)

    /* FIND GROUP NUMBER AND SIZE */

{
long m,n,sh,last ;

RD  bfct-=8 ; x=bff>>bfct&255 ;
#ifndef CIPHER
if (x<224) {error="wrong first character" ;
           goto err ; }
#else

         /* GENERATE KEY TABLE */

if (x<224-k1) {error="wrong first character for cipher" ;
           goto err ; }

if (k1) {long x ;
char * pt ;
unsigned char temp[256] ;
k3=0 ;
for (m=0 ; m<8 ; m++)  {
  x=getc(fpr) ;
  if (x==EOF) {  error=
        "early end of file" ;
        goto err ; }
  temp[m]=x ;
                       }
pt=argv[k2] ;
while ( temp[m++]= *pt++ ) ;
n=m ;
while (m<256)
   temp[m]= temp[m-1]>>3^temp[m-1]<<5^temp[m-n], m++ ;

    /* use randomised temp to make perm key
     so that key to password is difficult */
  { unsigned char a,b,c,d ;
    a=temp[91],b=temp[37], c=temp[161], d=temp[241] | 1 ;
    for (m=0 ; m<256 ; m++)
      key[m^a]=b^c, b+=d ;

  /* permute key by temp */
  k3=key[0] ; m=0 ; while (1) {
    k4=temp[m]^key[m] ;
    key[m]=key[k4] ;
    m++ ; if (m==256) break ;
    key[k4]=key[m] ; }
  key[k4]=k3 ;

  k4=key[87], k5=key[78], k3=temp[157] ;
  k1=0 ;
        }        }
#endif

   /*GENERATE USE ALPHABET */

n=0,sh=0,p=0, last=0 ;
while (n<257)
{
RD bfct-=2 ; z=bff>>bfct & 3 ;
if (z&2^last) sh=0 ;
if (z>1)                        {
 m=(z-1)<<sh++ ;
 while (m && n<258) r[p++]=n++, m-- ;    }
else  n+=z+1<<sh++ ;
last=z&2 ;
}
 chsz=p+2 ;
 if (n^257) { error="wrong usage table" ; goto err ;}
}

    /* SET FOR MULTIPLE TABLES  */
gpno=x>>2 &7 ;
gpno++ ;
gpsz=25<< (x&3) ;

if (gpno>1)
    /* GENERATE DECODE TABLES FOR TABLE
    SELECTION */
{long z,m,p,x,y ;
for (m=0 ; m<gpno+1 ; m++ ) {
  RD bfct-=6 ;
  x=(bff>>bfct)&63 ;
  y=x&7 ;
  x>>=3 ;
  for (p=y<<7-x,n=0 ; n<1<<7-x ; n++,p++)
    tbdec[p]=m^x+1<<4 ;     }
}

tab=space ; gpnoo=0 ; max8=8 ;

multiple :
tabch=tab+25 ;
tabval=tabch+25 ;
val8=tabval+260 ;
len8=val8+ (1<<FAST) ;

    /* READ LENGTH TABLES */
{{ long  t=0 , last=2 ;

for ( m=0 ; m<chsz ; )   {
  RD bfct-=2 ; z=bff>>bfct & 3 ;
  switch (z) {
  case 0 : break ;
  case 1 : last-=t+1 ; t=0 ; break ;
  case 2 : last+=t+1 ; t=0 ; break ;
  case 3 : t++ ; continue ;
              }
  len[m++]=last ;
  if ( last<1 || last >24 ) {
     error="decode tables wrong" ;
     goto err ;             }
                       }

    /* USE LENGTH TABLES TO DERIVE
    DECODING TABLES
tab gives length code starts,
tabch gives offset to code table
tabval gives symbol corresponding to code
FAST gives fast immediate table size ( bits )
val8 gives fast symbols,
len8 gives length or FAST+1  */

mx[gpnoo]=max= len[chsz-1] ;
if (max>max8) max8=max ;
mask=1<<max; mask-- ;
msk[gpnoo]=mask ;

x=huffgendec( len, chsz,
 tab,
 tabch,
 tabval,
 FAST,
 val8,
 len8) ;
if (x) {error="decode tables wrong" ; goto err ;}
}}

if (gpno^++gpnoo) { tab+=dspace ; goto multiple ; }

    /* READ, DECODE,REMOVE RELATIVE CODING
    AND 1/2 CODING */
y=k=s=0 ;
z1=r[0] ;
for (m=0 ; m<gpno ; m++ ) slist[m]=m ;
gct= (gpno>1) ? 1 : 0 ;
tab= space ;
tabch = tab +25 ;
tabval= tabch +25 ;
val8 = tabval+260 ;
len8 =val8 + (1<<FAST) ;
mask=msk[0] ;
max=mx[0] ;

jo :
    /* MULTIPLE TABLE SELECTOR */
if (--gct == 0)
    /* GET TABLE SELECTION */
{
static long ss ;
long x,z ;
  if (k==0) ss=0 ;
  RD
  x= ( bff>>bfct-8 )&255  ;
  x=tbdec[x] ;
  bfct-=x>>4 ;
  x&=15 ;
  if (x<2)  gct= gpsz<<ss++ +x ;
  else {
  x-=1 ;
  ss=0 ;
  z=slist[x] ;
  while (x) slist[x]=slist[x-1], x-- ;
  slist[0]=z ;
  tab= space+ z*dspace ;
  tabch = tab +25 ;
  tabval= tabch +25 ;
  val8 = tabval+260 ;
  len8 =val8 + (1<<FAST) ;
  max=mx[z] ;
  mask=msk[z] ;
  gct= gpsz ;
      }
}

RD z=bff>>bfct-FAST & FASTMASK ;
if ( (m=len8[z]) <FAST+1 )   {
  z=val8[z] ;
                        }
else  {
  x=bff>>bfct-max & mask ;
  while (x<tab[m]) m++ ;
  x-=tab[m] ;
  x>>=max-m ;
  x+=tabch[m] ;
  z=tabval[x] ;
      }
bfct-=m ;

/* z in range 0 - chsz-1, 01 give repeats */

if (k>bsize) { error= "blocksize too small" ;
             goto err ; }

if (z<2)    {
  y=z+1<<s++ ;
if(bsize<=(1U<<24))
  while (y--)
    v[k++]=z1<<24^tf[z1]++;
else
  while (y--)
{v[k]=tf[z1]++;((unsigned char *)v)[bsize*4+k]=z1;++k;}
  goto jo ; }

  /* move to front */
if (z<chsz-1)                 {
   z-- ; p=z ; z1=r[p] ;
   while (p) r[p]=r[p-1], p-- ;
   r[0]=z1 ;
   s=0 ;
if(bsize<=(1U<<24))
   v[k++]=z1<<24^tf[z1]++ ;
else
{v[k]=tf[z1]++;((unsigned char *)v)[bsize*4+k]=z1;++k;}
   goto jo ;               }

if (tf[256]^1)
    { error=
    "not exactly one end of text in block" ;
     goto err ; }

    /* UNRAVEL v AND FOLLOW CHAIN */
    /* sum frequencies */
n=0 ; z=1 ; s=0 ; k-- ;
for (m=0 ; m<256 ; m++)
y=tf[m], tf[m]=z, z+=y ;

y=0 ;
if(bsize<=(1U<<24))
while ( k-- >0 )                {
   z=v[n] ;
   z1=(z>>24)&0xff;
   n=(z&0x00ffffff) + tf[z1] ;
   putc(z1,fpw) ;              }
else
while ( k-- >0 )                {
{z1=((unsigned char *)v)[bsize*4+n];n=v[n]+tf[z1];}
   putc(z1,fpw) ;              }

    /* END OF FILE or GET NEXT PART */
z=getc(fpr) ;
if (z==EOF) break ;
ungetc(z,fpr) ;
}}

fclose(fpr) ; fclose(fpw) ;
if (keep) unlink(argv[argcc]) ;
if (silent&1)
printf("\n file %s restored as  %s\n",
argv[argcc],chl) ;
continue ;

     /* ERROR HANDLING */
err :  if(fpw)fclose(fpw);//;unlink(fpw); ??
err1 : if(fpr)fclose(fpr);
errct++ ;
fprintf(stderr,
 "\n bexp3 fails, file %s\n%s\n",
 argv[argcc],error) ;
}
return errct ; }

